// sumup.h
// Glenn G. Chappell
// 24 Sep 2013
// Header for class SumUp
// Has static member and friend

#ifndef FILE_SUMUP_H_INCLUDED
#define FILE_SUMUP_H_INCLUDED

// class SumUp
// Summing using a static data member
class SumUp {
// ***** SumUp: friend declarations *****

    friend int getTotal();

// ***** SumUp: ctors, dctor *****
public:

    // Ctor (default & 1-param)
    // Set _num to the given value
    SumUp(int num=0)
    {
        setNum(num);        
    }

    // Compiler-generated dctor used

// ***** SumUp: general public functions *****
public:

    // Get & set functions for _num
    int getNum() const
    {
        return _num;
    }
    void setNum(int num)
    {
        _num = num;
    }

    // addToTotal
    // Add our _num to class-wide _total
    void addToTotal() const
    {
        _total += _num;
    }

// ***** SumUp: member variables *****
private:

    int _num;           // Our number
    static int _total;  // Class-wide total (starts at 0)

};  // End class SumUp

// getTotal
// Return class-wide total for class SumUp
// Friend of class SumUp
int getTotal();

#endif //#ifndef FILE_SUMUP_H_INCLUDED

